(function ($) {
    $.fn.bootstrapModalManager = function (options) {
        // Define html templates
        var headTemplate = '<div class="modal-header"><button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button><h4 class="modal-title">{{title}}</h4></div>',
            bodyTemplate = '<div class="modal-body"><p>{{body}}</p></div>',
            footerTemplate = ' <div class="modal-footer">{{footerButtons}}</div>',
            containerTemplate = '<div class="modal fade" tabindex="-1" role="dialog"><div class="modal-dialog"><div class="modal-content"></div></div></div>'
            buttonTemplate = '<button type="button" class="btn {{classes}}" data-dismiss="modal">{{text}}</button>'
            
        // Extend the passed in options object.
        settings = $.extend({
            sections: {
                head: {
                    text: 'Test title',
                    buttons: []
                },
                body: {
                    text: 'A body of text.'
                },
                footer: {
                    buttons: [
                        {
                            classes: ['btn-default'],
                            text: 'Close',
                            action: null
                        },
                        {
                            classes: ['btn-primary'],
                            text: 'Save Changes',
                            action: null
                        }
                    ]
                }
            }
        }, options);
        
        // Create the modal
        var $modal = $(containerTemplate);        
        $modal.find('.modal-content')
            .append(headTemplate.replace('{{title}}', settings.sections.head.text))
            .append(bodyTemplate.replace('{{body}}', settings.sections.body.text))
            .append(footerTemplate.replace('{{footerButtons}}', constructButtons(settings.sections.footer.buttons)));

        // Add modal to the page and show.
        this.append($modal);
        $modal.modal();
        
        /**
         * Construct the buttons from the supplyed array.
         */
        function constructButtons(buttonList) {
            var buttons = '';
            for (var i = 0; i < buttonList.length; i++) {
                buttons += buttonTemplate
                    .replace('{{classes}}', buttonList[i].classes.join(' '))
                    .replace('{{text}}', buttonList[i].text);
            }
            return buttons;
        }
        
        return $modal;
    }
})($)